Skip to main content

Celebrity Problem - Medium


Problem : In a party of N people, only one person is known to everyone. Such a person may be present in the party, if yes, (s)he doesn't know anyone in the party. We can only ask questions like “does A know B? Find the celebrity in minimum number of questions.

This is a very interesting problem. The answer, ie the least number of questions required, changes based on what's given. Are we guaranteed there's one celebrity in the party? Does every non-celeb know every other non-celeb? ( not very ideal, but under a best case scenario. )

Once again, the rules
  • There is at most one celebrity at the party
  • Everyone knows the celebrity.
  • The celebrity knows no one.
  • We can only ask the question "Does A know B?"

When we ask the question, we can get a "yes" or "no". Each conveying information about both the participants in the question. Let's see those outcomes...

If the Answer is "Yes", we know A is definitely not a celebrity. But B is a candidate for a celebrity.

If the Answer is "No", we know both A and B are both candidates or both are Non-Celebrities.

Turns out, we can do this in linear time. We love those kinds, don't we?

Here we simply assume the first guy is a celeb. Each time you will ask a question
Does my assumed-celeb know the current-guy ?
 There are two outcomes,

  • If the answer is "Yes", we know our assumption was wrong,we can eliminate our assumption. But the next-guy could be a celeb. So we make him our new assumption.
  • If the answer is "No", our assumption is holding strong, we can safely eliminate the current-guy.


Evidently, every time you ask the question, one guy gets eliminated from candidacy. So we'll need to ask (n - 1) questions to get one strong candidate.

At this point, if we were assured there was one celeb we can end the algorithm here. If there's a possibility, there was no celebrity, we'll have to perform one more scan to eliminate the end guy as well.

Theoretically, that's (n - 1) questions. So we need to ask a minimum of 2(n-1) questions to figure out the celebrity. I'll attempt to prove the lower bound some other time, will be handy for my Algorithm class.


import random
N = 10
#prepare testcase
R = range(N)
rand_celeb = random.randint(0,N-1)
m = {}
for i in xrange(N):
if i != rand_celeb:
m[i] = [random.randint(0,N-1) for j in xrange(10)] + [rand_celeb]
else:
m[i] = []
def knows(i,j): #i knows j?
return j in m[i]
def find_celeb(n):
celeb = 0
for i in xrange(1,n):
if not knows(i,celeb):
celeb = i
for i in xrange(n):
if i != celeb and knows(celeb,i):
return None
return celeb
print R
print "Actual Celeb : ",rand_celeb
print "Found Celeb : ",find_celeb(len(R))
Let's extend this a bit, assume there were multiple celebrities at the party (or None). (A celeb doesn't know another celeb.) Although, I don't claim this is the most efficient algorithm, it certainly works. The first part of the solution remains the same, we find a celebrity, any one will do. Notice the original algorithm will do this for you. We include one more pass at the end, asking the question "Does X know Celebrity?". If the answer is "No", we KNOW that X is another celebrity. Here's the code.

import random
N = 100
#prepare testcase
R = range(N)
rand_celeb = list(set(random.randint(0,N-1) for i in xrange(5)))
m = {}
for i in xrange(N):
if i not in rand_celeb:
m[i] = [random.randint(0,N-1) for j in xrange(10)] +rand_celeb
else:
m[i] = []
def knows(i,j): #i knows j?
return j in m[i]
def find_celebs(n):
celeb = 0
for i in xrange(1,n):
if not knows(i,celeb):
celeb = i
celebs = []
for i in xrange(n):
if i != celeb and knows(celeb,i):
return None
if not knows(i,celeb):
celebs.append(i)
return celebs
print R
print "Actual Celeb : ",rand_celeb
print "Found Celeb : ",find_celebs(len(R))
Lovely question, Thanks to CodeBunk for posting it.

Comments

Popular posts from this blog

Find Increasing Triplet Subsequence - Medium

Problem - Given an integer array A[1..n], find an instance of i,j,k where 0 < i < j < k <= n and A[i] < A[j] < A[k]. Let's start with the obvious solution, bruteforce every three element combination until we find a solution. Let's try to reduce this by searching left and right for each element, we search left for an element smaller than the current one, towards the right an element greater than the current one. When we find an element that has both such elements, we found the solution. The complexity of this solution is O(n^2). To reduce this even further, One can simply apply the longest increasing subsequence algorithm and break when we get an LIS of length 3. But the best algorithm that can find an LIS is O(nlogn) with O( n ) space . An O(nlogn) algorithm seems like an overkill! Can this be done in linear time? The Algorithm: We iterate over the array and keep track of two things. The minimum value iterated over (min) The minimum increa...

Dijkstra's algorithm - Part 1 - Tutorial

This will be a 3 Part series of posts where I will be implementing the Dijkstra's Shortest Path algorithm in Python. The three parts will be 1) Representing the Graph 2) Priority Queue 3) The Algorithm To represent a graph we'll be using an  Adjacency List . Another alternative is using an Adjacency Matrix, but for a sparse graph an Adjacency List is more efficient. Adjacency List An Adjacency List is usually represented as a HashTable (or an Array) where an entry at `u` contains a Linked List. The Linked List contains `v` and optionally another parameter `w`. Here `u` and `v` are node(or vertex) labels and `w` is the weight of the edge. By Traversing the linked list we obtain the immediate neighbours of `u`. Visually, it looks like this. For implementing this in Python, we'll be using the dict()  for the main HashTable. For the Linked List we can use a list of 2 sized tuples (v,w).  Sidenote: Instead of a list of tuples, you can use a dict(), ...

Find the Quadruplets - Hard

Problem - Given 4 arrays A,B,C,D. Find out if there exists an instance where A[i] + B[j] + C[k] + D[l] = 0 Like the Find the Triple problem, we're going to develop 4 algorithms to solve this. Starting with the naive O(n^4) solution. Then we proceed to eliminate the inner-most loop with a Binary Search, reducing the complexity to O(n^3 logn) Now, we replace the last 2 loops with the left-right traversal we did in the previous 3 posts. Now the complexity is O(n^3). Finally, we reduce the complexity to O(n^2 logn) at the cost of O(n^2) Space Complexity. We store every combination of A[i] + B[j] and store it in AB[]. Similarly we make CD[] out of C[i] + D[j]. So, AB = A x B CD = C x D We then sort AB and CD (which costs O(n^2 log(n^2)) ~ O(n^2 logn) ) and then run a left-right linear Algorithm on AB and CD. (Note : Their size is of the order O(n^2)) So the overall complexity is due to sorting the large array of size n^2. which is O(n^2 logn).